\section{Related work}
\label{sec_related_works}
Since MemOpLight scales memory according to containers needs, we relate our work to auto-scaling.
Auto-scaling consists in adding or removing resources or replicas to follow application needs.

Products with auto-scaling already exist \cite{amazon_aws_2018, barr_new_2018, noauthor_microsoft_2017, noauthor_google_2018, noauthor_kubernetes_autoscaler_2019}.
The majority of the existing approaches use horizontal scaling (\textit{i.e.} add or delete a VM or a container).

Amazon's approach is particularly relevant, because it supports vertical scaling, \textit{i.e.}, giving to or taking resources from a VM or a container \cite{amazon_aws_2018}.
Compared to our solution, Amazon focus on all resources.
Allocated resources can be modified dynamically thanks to prediction.
This dynamic scaling will add or remove resources to maintain their use at fixed levels.
The predictive scaling analyzes up to 14 days of a metric use and is able to make predictions 2 days in the future.
The prediction grain is one hour.
This auto scaling will add or delete resources to conform with the prediction.
If the prediction was too weak the dynamic scaling will be activated.
The predictive scaling is based on machine learning.
MemOpLight can extend this scaling in case of memory pressure or to increase precision since it activates each second.

In research, auto-scaling also exist \cite{kriushanth_load_2015, lorido_botran_review_2014, moore_transforming_2013, rao_distributed_2011}.
Some use horizontal scaling \cite{kriushanth_load_2015, moore_transforming_2013}.
Lorido-Botran \textit{et al.} do horizontal scaling for containers \cite{lorido_botran_review_2014}.
They monitor the requests received by their web application during a given period.
They analyze and predict the number of requests to come during the next period.
Then, they compute the number of containers needed to face those requests.
Our approach can extend theirs by adding memory scaling to horizontal scaling.

The solution of Rao \textit{et al.} implements vertical scaling for VM \cite{rao_distributed_2011}.
A decision to add or remove resources will be assessed to know if it increases VM's performance.
Otherwise, the system will learn not to take this decision anymore.
An improvement of their solution can consist of using MemOpLight if the system took a bad decision.

Dupont \textit{et al.} base their approach on MAPE-K loop \cite{dupont_experimental_2015}.
Their approach is innovative in the way that, when a peak of load occurs, they scale the software running by either add/remove function (\textit{e.g.} security features, logging, \textit{etc.}) or increase/decrease quality of execution (\textit{e.g.} decreasing video quality).
Their work can be related to us in the sense that we do not scale horizontally or vertically, we just do better with that we have.

Carver \textit{et al.} focus on containers \cite{carver_acdc_2017}.
Since, under memory pressure, all memory \texttt{cgroups} are reclaimed they propose to modify Linux memory reclamation algorithm, to target first the least recently active container.
This solution avoids performance drop of active containers because they are not reclaimed anymore.
As they do not take into account application feedback, it is possible that a green container is always recently activated and thus, never gives up its memory under their solution.
MemOpLight could be used in combination with this solution to decide from which green container the kernel should reclaim memory based on the activity.

Compared to all these works, ours is unique in the way that we ensure container satisfaction.
MemOpLight is also original in the way that it bases its reclaim on containers' performance as reported by probes.